Missing / Null Values in JavaScript

Using ApexCharts with JavaScript

This Missing / Null Values example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
var options = {
  series: [
    {
      name: 'us-east-1',
      data: [
        142,
        138,
        155,
        149,
        151,
        144,
        139,
        null,
        null,
        null,
        158,
        162,
        147,
        150,
        141,
        146,
      ],
    },
    {
      name: 'eu-west-1',
      data: [
        210,
        225,
        null,
        218,
        null,
        208,
        215,
        228,
        null,
        null,
        219,
        null,
        224,
        null,
        null,
        null,
      ],
    },
    {
      name: 'ap-south-1',
      data: [
        null,
        null,
        null,
        null,
        296,
        301,
        288,
        295,
        302,
        310,
        318,
        324,
        305,
        null,
        null,
        null,
      ],
    },
  ],
  chart: {
    height: 350,
    type: 'line',
    zoom: {
      enabled: false,
    },
    animations: {
      enabled: false,
    },
  },
  stroke: {
    width: [5, 5, 4],
    curve: 'smooth',
  },
  labels: [
    '2025-06-04T00:00:00',
    '2025-06-04T01:00:00',
    '2025-06-04T02:00:00',
    '2025-06-04T03:00:00',
    '2025-06-04T04:00:00',
    '2025-06-04T05:00:00',
    '2025-06-04T06:00:00',
    '2025-06-04T07:00:00',
    '2025-06-04T08:00:00',
    '2025-06-04T09:00:00',
    '2025-06-04T10:00:00',
    '2025-06-04T11:00:00',
    '2025-06-04T12:00:00',
    '2025-06-04T13:00:00',
    '2025-06-04T14:00:00',
    '2025-06-04T15:00:00',
  ],
  title: {
    text: 'API Response Time by Region',
  },
  subtitle: {
    text: 'Monitoring dropouts (null values) render as gaps',
  },
  xaxis: {
    type: 'datetime',
    labels: {
      format: 'HH:mm',
    },
  },
  yaxis: {
    labels: {
      formatter: function (val) {
        return val + ' ms'
      },
    },
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

Missing / Null Values in React

Using ApexCharts with React

This Missing / Null Values example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [
      {
        name: 'us-east-1',
        data: [
          142,
          138,
          155,
          149,
          151,
          144,
          139,
          null,
          null,
          null,
          158,
          162,
          147,
          150,
          141,
          146,
        ],
      },
      {
        name: 'eu-west-1',
        data: [
          210,
          225,
          null,
          218,
          null,
          208,
          215,
          228,
          null,
          null,
          219,
          null,
          224,
          null,
          null,
          null,
        ],
      },
      {
        name: 'ap-south-1',
        data: [
          null,
          null,
          null,
          null,
          296,
          301,
          288,
          295,
          302,
          310,
          318,
          324,
          305,
          null,
          null,
          null,
        ],
      },
    ],
    options: {
      chart: {
        height: 350,
        type: 'line',
        zoom: {
          enabled: false,
        },
        animations: {
          enabled: false,
        },
      },
      stroke: {
        width: [5, 5, 4],
        curve: 'smooth',
      },
      labels: [
        '2025-06-04T00:00:00',
        '2025-06-04T01:00:00',
        '2025-06-04T02:00:00',
        '2025-06-04T03:00:00',
        '2025-06-04T04:00:00',
        '2025-06-04T05:00:00',
        '2025-06-04T06:00:00',
        '2025-06-04T07:00:00',
        '2025-06-04T08:00:00',
        '2025-06-04T09:00:00',
        '2025-06-04T10:00:00',
        '2025-06-04T11:00:00',
        '2025-06-04T12:00:00',
        '2025-06-04T13:00:00',
        '2025-06-04T14:00:00',
        '2025-06-04T15:00:00',
      ],
      title: {
        text: 'API Response Time by Region',
      },
      subtitle: {
        text: 'Monitoring dropouts (null values) render as gaps',
      },
      xaxis: {
        type: 'datetime',
        labels: {
          format: 'HH:mm',
        },
      },
      yaxis: {
        labels: {
          formatter: function (val) {
            return val + ' ms'
          },
        },
      },
    },
  })

  return (
    <div>
      <div id="chart">
        <ReactApexChart
          options={state.options}
          series={state.series}
          type="line"
          height={350}
        />
      </div>
    </div>
  )
}

export default ApexChart

Missing / Null Values in Angular

Using ApexCharts with Angular

This Missing / Null Values example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  public chartOptions: Partial<ChartOptions> = {
          series: [
            {
              name: 'us-east-1',
              data: [
                142,
                138,
                155,
                149,
                151,
                144,
                139,
                null,
                null,
                null,
                158,
                162,
                147,
                150,
                141,
                146,
              ],
            },
            {
              name: 'eu-west-1',
              data: [
                210,
                225,
                null,
                218,
                null,
                208,
                215,
                228,
                null,
                null,
                219,
                null,
                224,
                null,
                null,
                null,
              ],
            },
            {
              name: 'ap-south-1',
              data: [
                null,
                null,
                null,
                null,
                296,
                301,
                288,
                295,
                302,
                310,
                318,
                324,
                305,
                null,
                null,
                null,
              ],
            },
          ],
          chart: {
            height: 350,
            type: 'line',
            zoom: {
              enabled: false,
            },
            animations: {
              enabled: false,
            },
          },
          stroke: {
            width: [5, 5, 4],
            curve: 'smooth',
          },
          labels: [
            '2025-06-04T00:00:00',
            '2025-06-04T01:00:00',
            '2025-06-04T02:00:00',
            '2025-06-04T03:00:00',
            '2025-06-04T04:00:00',
            '2025-06-04T05:00:00',
            '2025-06-04T06:00:00',
            '2025-06-04T07:00:00',
            '2025-06-04T08:00:00',
            '2025-06-04T09:00:00',
            '2025-06-04T10:00:00',
            '2025-06-04T11:00:00',
            '2025-06-04T12:00:00',
            '2025-06-04T13:00:00',
            '2025-06-04T14:00:00',
            '2025-06-04T15:00:00',
          ],
          title: {
            text: 'API Response Time by Region',
          },
          subtitle: {
            text: 'Monitoring dropouts (null values) render as gaps',
          },
          xaxis: {
            type: 'datetime',
            labels: {
              format: 'HH:mm',
            },
          },
          yaxis: {
            labels: {
              formatter: (val) => {
                return val + ' ms'
              },
            },
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}

<template>
  <div>
    <div id="chart">
      <apexchart
        type="line"
        height="350"
        :options="chartOptions"
        :series="series"
      ></apexchart>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: [
        {
          name: 'us-east-1',
          data: [
            142,
            138,
            155,
            149,
            151,
            144,
            139,
            null,
            null,
            null,
            158,
            162,
            147,
            150,
            141,
            146,
          ],
        },
        {
          name: 'eu-west-1',
          data: [
            210,
            225,
            null,
            218,
            null,
            208,
            215,
            228,
            null,
            null,
            219,
            null,
            224,
            null,
            null,
            null,
          ],
        },
        {
          name: 'ap-south-1',
          data: [
            null,
            null,
            null,
            null,
            296,
            301,
            288,
            295,
            302,
            310,
            318,
            324,
            305,
            null,
            null,
            null,
          ],
        },
      ],
      chartOptions: {
        chart: {
          height: 350,
          type: 'line',
          zoom: {
            enabled: false,
          },
          animations: {
            enabled: false,
          },
        },
        stroke: {
          width: [5, 5, 4],
          curve: 'smooth',
        },
        labels: [
          '2025-06-04T00:00:00',
          '2025-06-04T01:00:00',
          '2025-06-04T02:00:00',
          '2025-06-04T03:00:00',
          '2025-06-04T04:00:00',
          '2025-06-04T05:00:00',
          '2025-06-04T06:00:00',
          '2025-06-04T07:00:00',
          '2025-06-04T08:00:00',
          '2025-06-04T09:00:00',
          '2025-06-04T10:00:00',
          '2025-06-04T11:00:00',
          '2025-06-04T12:00:00',
          '2025-06-04T13:00:00',
          '2025-06-04T14:00:00',
          '2025-06-04T15:00:00',
        ],
        title: {
          text: 'API Response Time by Region',
        },
        subtitle: {
          text: 'Monitoring dropouts (null values) render as gaps',
        },
        xaxis: {
          type: 'datetime',
          labels: {
            format: 'HH:mm',
          },
        },
        yaxis: {
          labels: {
            formatter: function (val) {
              return val + ' ms'
            },
          },
        },
      },
    }
  },
}
</script>

<style>
#chart {
  max-width: 650px;
  margin: 35px auto;
}
</style>